#pragma once

#include <QQuickItem>
#include <QVariant>
#include <QColor>
#include <QList>
#include <QPointF>
#include <QPolygonF>
#include <QSGNode>
#include <QSGGeometry>
#include <QSGGeometryNode>
#include <QSGVertexColorMaterial>
#include <unordered_map>
#include <vector>
#include <QDateTime>


struct verticsInfo {

    verticsInfo() : normPos(0.0, 0.0),
     wndPos(0.0, 0.0),
     color(0, 0, 0),
     tex(0.0, 0.0),
     normal(0.0, 0.0) {

    }

    QPointF normPos;
    QPointF wndPos;
    QColor  color;
    QPointF tex;
    QPointF normal;
};


class QGrid : public QQuickItem {

    Q_OBJECT

public:
    explicit QGrid(QQuickItem * parent = nullptr);
    virtual ~QGrid() override;

public slots: //Add public Slots

signals: //Add Signals


protected:
    virtual QSGNode * updatePaintNode(QSGNode * old_node, UpdatePaintNodeData * update_paint_node_data) override;

    void timerEvent(QTimerEvent *event) override;

    bool makeGrid(unsigned int totalWidthDivsion, unsigned int totalHeightDivision,
                                                   qreal wndWidth, qreal wndHeight);

    void ClearData();

protected slots:


private:
    QVector<std::shared_ptr<verticsInfo>>           m_list_vertics;
    int                                             m_timer_id;
    double                                          m_start_time; // seconds
    int                                             m_qitem_width;
    int                                             m_qitem_height;
    unsigned int numberof_horzontaldivision   = 200;
    unsigned int numberof_verticaldivision    = 200;

    const std::string TAG = "QGrid";
};

